/*!
 * bootstrap-for-vue v0.1.17
 * (c) 2017 Rahul Kadyan
 * Released under the MIT License.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var Sifter = _interopDefault(require('sifter'));
var vueClickaway = require('vue-clickaway');
var debounce = _interopDefault(require('lodash.debounce'));

var Alert = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.inDOM)?_c('div',{staticClass:"alert",class:[("alert-" + (_vm.type))],attrs:{"role":"alert"}},[(_vm.dismissable)?_c('button',{staticClass:"close",attrs:{"type":"button","aria-label":"Close"},on:{"click":_vm.dismiss}},[_c('span',{attrs:{"aria-hidden":"true"}},[_vm._v("×")])]):_vm._e(),_vm._t("default",[_vm._v(_vm._s(_vm.message))])],2):_vm._e()},staticRenderFns: [],
  name: 'Alert',

  props: {
    message: {
      type: String
    },

    type: {
      type: String,
      default: 'success'
    },

    dismissable: {
      type: Boolean,
      default: true
    },

    removeFromDOM: {
      type: Boolean,
      default: true
    }
  },

  data: function data () {
    return {
      inDOM: true
    }
  },

  methods: {
    /**
     * Dismiss alert.
     *
     * @return {undefined}
     */
    dismiss: function dismiss () {
      this.$emit('dismiss');

      if (this.removeFromDOM) {
        this.inDOM = false;
      }
    }
  }
};

var Breadcrumb = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('nav',{staticClass:"breadcrumb"},_vm._l((_vm.crumbs),function(crumb){return _c(_vm.component,{tag:"div",staticClass:"breadcrumb-item",attrs:{"to":crumb.link,"active-class":"active"}},[_vm._v(_vm._s(crumb.title))])}))},staticRenderFns: [],
  props: {
    links: {
      type: Array,
      required: true
    },

    component: {
      type: String,
      default: 'router-link'
    }
  },

  computed: {
    crumbs: function crumbs () {
      var links = this.links;

      if (typeof (links[0]) === 'string') {
        return links.map(function (link) { return ({ link: link, title: link }); })
      }

      return links
    }
  }
};

var CheckboxWrapper = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('fieldset',{staticClass:"form-group"},[(_vm.title)?_c('legend',{staticClass:"bootstrap-for-vue-CheckboxWrapper-wrapper-legend"},[_vm._v(_vm._s(_vm.title))]):_vm._e(),_vm._t("default")],2)},staticRenderFns: [],cssModules: {"wrapperLegend":"bootstrap-for-vue-CheckboxWrapper-wrapper-legend","wrapper-legend":"bootstrap-for-vue-CheckboxWrapper-wrapper-legend"},
  name: 'CheckboxWrapper',

  props: {
    title: {
      type: String,
      default: null
    }
  }
};

var Dropdown = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{class:[("drop" + (_vm.type)), (_vm.show ? 'show' : '')]},[_vm._t("default"),(_vm.items.length)?_c('div',{staticClass:"dropdown-menu"},[_vm._t("items",_vm._l((_vm.items),function(item,index){return _c(_vm.component,_vm._b({key:item,tag:"div",staticClass:"dropdown-item",class:{ active: _vm.active === index },attrs:{"role":"button"},on:{"click":function($event){$event.preventDefault();_vm.$emit('select', item);}},nativeOn:{"click":function($event){$event.preventDefault();_vm.$emit('select', item);}}},'div',{ active: _vm.active === index, selected: _vm.selected.indexOf(item) > -1, item: item}),[_vm._v(_vm._s(item[_vm.itemKey]))])}))],2):_c('div',{staticClass:"dropdown-menu"},[_vm._t("empty")],2)],2)},staticRenderFns: [],
  props: {
    show: {
      type: Boolean,
      required: true
    },

    active: {},

    selected: {
      type: [Array]
    },

    type: {
      validator: function validator (type) {
        return ['up', 'down'].indexOf(type) > -1
      },
      default: 'down'
    },

    items: {
      type: Array,
      required: true
    },

    itemKey: {
      type: String,
      default: 'name'
    },

    component: {
      type: String,
      default: 'div'
    }
  }
};

var Icon = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('i',{staticClass:"fa",class:[_vm.typeName]})},staticRenderFns: [],
  name: 'Icon',

  props: {
    type: {
      required: true,
      type: String
    }
  },

  computed: {
    typeName: function typeName () {
      return ("fa-" + (this.type))
    }
  }
};

function isArray (any) {
  return typeof (any) === 'object' && any instanceof Array
}

function isObject (any) {
  return any !== null && typeof (any) === 'object'
}

function mapObject (source, take) {
  var target = {};

  if (isArray(take)) {
    take.forEach(function (key) {
      if (key in source) {
        target[key] = source[key];
      }
    });
  } else {
    Object.keys(take).forEach(function (sourceKey) {
      var targetKey = take[sourceKey];

      if (sourceKey in source) {
        target[targetKey] = source[sourceKey];
      }
    });
  }

  return target
}

function getDirectiveExpression (vnode, name) {
  if (!vnode || !vnode.data || !(vnode.data.directives instanceof Array)) { return null }

  if (!/^v-.*/.test(name)) { name = "v-" + name; }

  for (var i = 0; i < vnode.data.directives.length; i += 1) {
    var directive$$1 = vnode.data.directives[i];

    if (directive$$1.rawName === name) {
      return directive$$1.expression
    }
  }

  return null
}

var getExpression = {
  methods: {
    getExpression: function getExpression (key, type) {
      if ( type === void 0 ) type = 'directive';

      if (!this.$vnode) { return null }

      if (type === 'directive') { return getDirectiveExpression(this.$vnode, key) }

      return null
    }
  }
};

var inputHelper = {
  props: {
    value: { required: true },
    title: { type: String, default: null },
    subtitle: { type: String, default: null },
    name: { type: String, default: null },
    inputName: { type: String, default: null },
    errors: {
      validator: function validator (errors) {
        return typeof (errors) === 'object' && typeof (errors.has) === 'function'
      },
      default: null
    },
    inputClass: String,
    placeholder: String,
    autofill: [String, Boolean],
    autocomplete: [String, Boolean],
    autofocus: [Boolean],
    min: {},
    max: {},
  },

  data: function data () {
    return {
      expression: null,
      required: null
    }
  },

  computed: {
    /**
     * Unique ID.
     *
     * @property id
     * @return {string}
     */
    id: function id () {
      return ("text" + (this._uid))
    },

    /**
     * Input field name.
     *
     * @property nameKey
     * @type {string}
     */
    nameKey: function nameKey () {
      var inputName = this.inputName;
      var expression = this.expression;

      if (inputName) { return inputName }

      return expression
    },

    /**
     * Get error or feedback for the input field.
     *
     * @property feedback
     * @type {string|null}
     */
    feedback: function feedback () {
      var errors = this.errors;
      var name = this.nameKey;

      if (errors) {
        return errors.get(name)
      }

      return null
    }
  },

  methods: {
    /**
     * Mirror attributes from root element.
     *
     * @return {void}
     */
    updateAttributes: function updateAttributes () {
      if (!this.$vnode || !this.$vnode.data || !this.$vnode.data.attrs) { return }

      this.required = this.$vnode.data.attrs.hasOwnProperty('required');
    }
  },

  mounted: function mounted () {
    var this$1 = this;

    var model = this.getExpression('model');

    if (model) {
      this.expression = model.split('.').pop();
    }
    this.updateAttributes();

    if (this.autofocus !== false) {
      this.$nextTick(function () {
        var el = this$1.$el.querySelector('[autofocus]');
        if (el) { el.focus(); }
      });
    }
  },

  beforeUpdate: function beforeUpdate () {
    this.updateAttributes();
  },

  mixins: [getExpression]
};

var checkbox = {
  name: 'InputBox',

  props: {
    value: {
      type: [Array, String, Number, Boolean],
      required: true
    },

    radio: {
      default: undefined
    },

    checkbox: {
      default: true
    },

    inline: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    /**
     * Type of field (radio/checkbox)
     *
     * @type {String}
     */
    type: function type () {
      var radio = this.radio;

      if (radio !== undefined) { return 'radio' }

      return 'checkbox'
    },

    /**
     * Value of the checkbox (If checked, value of the model would be set to this).
     *
     * @type {number|string|bool}
     */
    localValue: function localValue () {
      var radio = this.radio;
      var checkbox = this.checkbox;

      if (radio !== undefined) { return radio }

      return checkbox
    },

    /**
     * Current state of the box/radio.
     *
     * @type {bool}
     */
    state: function state () {
      var value = this.value;
      var localValue = this.localValue;

      if (isArray(value)) {
        return value.indexOf(localValue) > -1
      }

      return value === localValue
    }
  },

  methods: {
    /**
     * Handle check/uncheck event.
     *
     * @return {void}
     */
    onChange: function onChange () {
      if (this.state) {
        this.uncheck();
      } else {
        this.check();
      }
    },

    /**
     * Mark box/radio as checked.
     *
     * @return {void}
     */
    check: function check () {
      if (this.type === 'checkbox' && isArray(this.value)) {
        var value = this.value.slice(0); // Copy Array.

        value.push(this.localValue);
        this.$emit('input', value);

        return
      }

      this.$emit('input', this.localValue);
    },

    /**
     * Mark box/radio as unchecked.
     */
    uncheck: function uncheck () {
      if (this.type === 'radio') { return }

      if (this.value instanceof Array) {
        var value = this.value.slice(0);

        value.splice(value.indexOf(this.localValue), 1);
        this.$emit('input', value);

        return
      }

      if (this.localValue === true) {
        this.$emit('input', false);

        return
      }

      this.$emit('input', null);
    }
  },

  mixins: [inputHelper]
};

var CustomBox = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-check bootstrap-for-vue-CustomBox-checkbox",class:{ 'has-danger': _vm.feedback, 'form-check-inline': _vm.inline },attrs:{"checked":_vm.state}},[_c('label',{staticClass:"bootstrap-for-vue-CustomBox-indicator"},[_c('input',_vm._b({staticClass:"bootstrap-for-vue-CustomBox-custom-control-input",domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.nameKey, autofocus: _vm.autofocus, autocomplete: _vm.autocomplete })),_vm._v(" "),(_vm.title)?_c('span',[_vm._v(_vm._s(_vm.title || ' '))]):_vm._e()])])},staticRenderFns: [],cssModules: {"checkbox":"bootstrap-for-vue-CustomBox-checkbox","indicator":"bootstrap-for-vue-CustomBox-indicator","customControlInput":"bootstrap-for-vue-CustomBox-custom-control-input","custom-control-input":"bootstrap-for-vue-CustomBox-custom-control-input"},
  mixins: [checkbox]
};

var BootstrapBox = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-check",class:{ 'has-danger': _vm.feedback, 'form-check-inline': _vm.inline }},[_c('label',{staticClass:"custom-control",class:[("custom-" + (_vm.type))]},[_c('input',_vm._b({staticClass:"custom-control-input",attrs:{"hidden":""},domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.nameKey, autofocus: _vm.autofocus, autocomplete: _vm.autocomplete })),_vm._v(" "),_c('span',{staticClass:"custom-control-indicator"}),_vm._v(" "),(_vm.title)?_c('span',{staticClass:"custom-control-description"},[_vm._v(_vm._s(_vm.title))]):_vm._e()])])},staticRenderFns: [],
  mixins: [checkbox]
};

var InputBox = {
  functional: true,

  render: function render (h, ref) {
    var props = ref.props;
    var data = ref.data;
    var children = ref.children;

    if (props.custom) { return h(CustomBox, data, children) }

    return h(BootstrapBox, data, children)
  },

  props: {
    custom: {
      type: Boolean,
      default: false
    }
  }
};

var InputButton = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('button',{staticClass:"btn",class:[_vm.styles],attrs:{"type":_vm.type,"role":"button"}},[(_vm.icon)?_c('icon',{staticClass:"mr-2",attrs:{"type":_vm.icon}}):_vm._e(),_vm._t("default",[_vm._v(_vm._s(_vm.value))])],2)},staticRenderFns: [],
  name: 'InputButton',

  props: {
    icon: {
      type: String,
      default: null
    },

    variant: {
      type: String,
      default: 'primary'
    },

    type: {
      type: String,
      default: 'button'
    },

    value: {
      type: String,
      default: null
    }
  },

  computed: {
    styles: function styles () {
      return [("btn-" + (this.variant))]
    }
  },

  components: { Icon: Icon }
};

var SearchField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-control bootstrap-for-vue-Search-input-search"},[(_vm.isEmpty)?_c('div',{staticClass:"bootstrap-for-vue-Search-input-search-placeholder"},[(_vm.icon)?_c('icon',{staticClass:"mr-1",attrs:{"type":_vm.icon}}):_vm._e(),_c('input',{staticClass:"input-search-proxy",attrs:{"type":"text","readonly":"","tabindex":"-1"},domProps:{"value":_vm.placeholder}})],1):_vm._e(),(!_vm.isEmpty && _vm.hasSuggestion && _vm.show)?_c('input',{staticClass:"bootstrap-for-vue-Search-input-search-suggestion",attrs:{"type":"text","readonly":"","tabindex":"-1"},domProps:{"value":_vm.suggestion}}):_vm._e(),_vm._v(" "),_c('input',_vm._b({staticClass:"bootstrap-for-vue-Search-input-search-field",attrs:{"type":"search"},on:{"keydown":function (e) { return _vm.$emit('keydown', e); },"keyup":function (e) { return _vm.$emit('keyup', e); },"keypress":function (e) { return _vm.$emit('keypress', e); },"input":function($event){_vm.$emit('input', $event.target.value);},"focus":_vm.onFocus,"blur":_vm.onBlur}},'input',{ autofocus: _vm.autofocus, autocomplete: _vm.autocomplete, value: _vm.value }))])},staticRenderFns: [],cssModules: {"inputSearch":"bootstrap-for-vue-Search-input-search","input-search":"bootstrap-for-vue-Search-input-search","inputSearchPlaceholder":"bootstrap-for-vue-Search-input-search-placeholder","input-search-placeholder":"bootstrap-for-vue-Search-input-search-placeholder","inputSearchSuggestion":"bootstrap-for-vue-Search-input-search-suggestion","input-search-suggestion":"bootstrap-for-vue-Search-input-search-suggestion","inputSearchField":"bootstrap-for-vue-Search-input-search-field","input-search-field":"bootstrap-for-vue-Search-input-search-field"},
  name: 'Search',

  props: {
    suggestion: {
      type: String
    },
    placeholder: {
      type: String,
      default: 'Search...'
    },
    value: {
      type: String,
      required: true
    },
    icon: {
      type: [String, Boolean],
      default: 'search'
    },
    autofocus: [Boolean],
    autocomplete: [String, Boolean]
  },

  data: function data () {
    return { show: false }
  },

  computed: {
    /**
     * Whether suggestion is available or not?
     *
     * @type {Boolean}
     */
    hasSuggestion: function hasSuggestion () {
      var suggestion = this.suggestion;

      return typeof (suggestion) === 'string' && suggestion.length > 0
    },

    /**
     * Whether input field is empty or not?
     *
     * @type {Boolean}
     */
    isEmpty: function isEmpty () {
      var value = this.value;

      return typeof (value) === 'string' && value.length === 0
    }
  },

  methods: {
    onBlur: function onBlur (event) {
      this.show = false;

      this.$emit('blur', event);
    },
    onFocus: function onFocus (event) {
      this.show = true;

      this.$emit('focus', event);
    }
  },

  components: { Icon: Icon }
};

var InputSearch = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('search-field',_vm._b({staticClass:"form-control",class:[_vm.inputClass],attrs:{"id":_vm.id},on:{"input":function (val) { return _vm.$emit('input', val); }}},'search-field',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, suggestion: _vm.suggestion, name: _vm.name, autocomplete: _vm.autocomplete })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputSearch',

  props: {
    suggestion: {
      type: String
    }
  },

  components: { SearchField: SearchField },
  mixins: [inputHelper]
};

var InputSelect = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._v(_vm._s(_vm.title))]):_vm._e(),_c('select',_vm._b({staticClass:"form-control custom-select",class:[_vm.inputClass],on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'select',{ id: _vm.id, value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, multiple: _vm.multiple, name: _vm.name }),[(_vm.placeholder)?_c('option',{attrs:{"disabled":"disabled"},domProps:{"selected":_vm.value === '' || _vm.value === null}},[_vm._v(_vm._s(_vm.placeholder))]):_vm._e(),_vm._l((_vm.selectOptions),function(option){return _c('option',{attrs:{"disabled":_vm.getDisabled(option)},domProps:{"value":_vm.getValue(option)}},[_vm._v(_vm._s(_vm.getDisplay(option)))])})],2),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._v(_vm._s(_vm.subtitle))]):_vm._e()])},staticRenderFns: [],
  name: 'InputSelect',

  props: {
    options: {
      type: [Array, Object],
      required: true
    },
    multiple: {
      type: [Boolean, Number],
      default: false
    },
    valueKey: {
      type: String,
      default: 'id'
    },
    displayKey: {
      type: String,
      default: 'name'
    },
    disabledKey: {
      type: String,
      default: 'disabled'
    }
  },

  computed: {
    selectOptions: function selectOptions () {
      var this$1 = this;

      var options = this.options;

      if (isArray(options)) {
        return options
      }

      return Object.keys(options).map(function (id) {
        var option = (isObject(options[id]) ? options[id] : ( obj = {}, obj[this$1.displayKey] = options[id], obj ));
        var obj;

        option[this$1.valueKey] = id;

        return option
      })
    }
  },

  methods: {

    getValue: function getValue (option) {
      return option[this.valueKey]
    },

    getDisplay: function getDisplay (option) {
      return option[this.displayKey]
    },

    getDisabled: function getDisabled (option) {
      return this.disabledKey.charAt(0) === '!' ? !option[this.disabledKey.substring(1)] : option[this.disabledKey]
    }

  },

  mixins: [inputHelper]
};

var InputText = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('input',_vm._b({staticClass:"form-control",class:[_vm.inputClass],attrs:{"id":_vm.id},on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'input',{ type: _vm.type, value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, autocomplete: _vm.autocomplete, min: _vm.min, max: _vm.max, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputText',

  props: {
    type: {
      type: String,
      default: 'text'
    }
  },

  mixins: [inputHelper]
};

var InputTextarea = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('textarea',_vm._b({staticClass:"form-control",class:[ _vm.resizeableClass, _vm.inputClass ],attrs:{"id":_vm.id,"type":"text"},on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'textarea',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, autocomplete: _vm.autocomplete, rows: _vm.rows, cols: _vm.cols, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputTextarea',

  props: {
    resizeable: {
      type: [String, Boolean],
      default: 'none'
    },
    rows: {
      type: Number,
      default: 5
    },
    cols: {
      type: Number,
      default: null
    }
  },

  computed: {
    resizableClass: function resizableClass () {
      var resize = this.resizable;

      if (resize === true) { return 'resizable' }
      if (resize === false) { return 'resizable-none' }
      if (!resize) { return '' }
      return ("resizable-" + resize)
    }
  },

  mixins: [inputHelper]
};

var TypeaheadField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('dropdown',_vm._b({directives:[{name:"on-click-away",rawName:"v-on-click-away",value:(_vm.close),expression:"close"}],staticClass:"bootstrap-for-vue-typeahead",on:{"select":_vm.onItemSelected}},'dropdown',{ items: _vm.items, show: _vm.show, component: _vm.component, itemKey: _vm.suggestionValue, active: _vm.index, selected: _vm.selected }),[_c('search-field',_vm._b({ref:"search",class:[_vm.inputClass],on:{"input":function (val) { return _vm.$emit('search', val); },"keydown":[function($event){if(_vm._k($event.keyCode,"down",40)){ return null; }_vm.onDown($event);},function($event){if(_vm._k($event.keyCode,"up",38)){ return null; }_vm.onUp($event);},function($event){if(_vm._k($event.keyCode,"enter",13)){ return null; }$event.preventDefault();_vm.onEnter($event);},function($event){if(_vm._k($event.keyCode,"tab",9)){ return null; }_vm.onTab($event);}],"focus":function($event){_vm.show = true;},"blur":_vm.onBlur},model:{value:(_vm.query),callback:function ($$v) {_vm.query=$$v;}}},'search-field',{ placeholder: _vm.placeholder, suggestion: _vm.suggestion, icon: _vm.icon, name: _vm.name, autocomplete: _vm.autocomplete, autofocus: _vm.autofocus }),[_vm._t("default")],2),(_vm.showEmpty)?_c('div',{staticClass:"px-3 text-muted",slot:"empty"},[_vm._v("No results :(")]):_vm._e()],1)},staticRenderFns: [],
  props: Object.assign({}, {value: {
      type: [Array, String, Number],
      required: true
    },

    suggestions: {
      type: Array,
      required: true
    },

    inputClass: String,

    suggestionValue: {
      type: String,
      default: 'name'
    },

    search: {
      type: [Object, Array]
    },

    filter: {
      type: Function,
      default: function () { return true; }
    },

    component: {
      type: String
    },

    showEmpty: {
      type: Boolean,
      default: true
    }},

    mapObject(SearchField.props, ['placeholder', 'icon', 'autofocus', 'autocomplete'])),

  data: function data () {
    return {
      show: false,
      q: '',
      index: -1,
      skip: false
    }
  },

  computed: {
    query: {
      get: function get () {
        var show = this.show;
        var value = this.value instanceof Array ? this.value : [this.value];
        var suggestionValue = this.suggestionValue;
        var q = this.q;

        if (show) { return q }

        return value.map(function (v) { return v[suggestionValue]; }).join(', ')
      },

      set: function set (val) {
        this.q = val;
      }
    },

    indexed: function indexed () {
      return new Sifter(this.suggestions)
    },

    selected: function selected () {
      var value = this.value;

      if (value instanceof Array) { return value }

      return [value]
    },

    config: function config () {
      var search = this.search;
      var displayField = this.suggestionValue;

      var config = {
        fields: [displayField],
        sort: [{ field: displayField, direction: 'asc' }],
        limit: 25
      };

      if (isArray(search)) {
        config.fields = search;

        return config
      }

      if (isObject(search)) {
        return Object.assign({}, config, search)
      }

      return config
    },

    items: function items () {
      var this$1 = this;

      var indexed = this.indexed;
      var config = this.config;
      var value = this.q;

      var results = indexed.search(value, config);

      return results.items.map(function (ref) {
        var id = ref.id;

        return this$1.suggestions[id];
      }).filter(this.filter)
    },

    suggestionItem: function suggestionItem () {
      var suggestions = this.items;
      var value = this.q;
      var key = this.suggestionValue;

      var suggestion = suggestions.find(function (suggestion) { return typeof (suggestion[key]) === 'string' && suggestion[key].startsWith(value); });

      if (suggestion) { return suggestion }

      return null
    },

    suggestion: function suggestion () {
      var item = this.suggestionItem;
      var key = this.suggestionValue;

      if (item) { return item[key] }

      return ''
    }
  },

  methods: {
    onItemSelected: function onItemSelected (item) {
      var this$1 = this;

      this.$el.querySelector('input[type=search]').focus();

      this.$nextTick(function () {
        console.log('BLUR IT');
        this$1.blur();
      });

      this.$emit('select', item);
    },

    onDown: function onDown () {
      if (this.index + 1 < this.items.length) {
        this.index += 1;
      } else {
        this.index = 0;
      }

      this.scrollIntoView();
    },

    onUp: function onUp () {
      if (this.index > 0) { this.index -= 1; }
      else { this.index = this.items.length - 1; }

      this.scrollIntoView();
    },

    onEnter: function onEnter () {
      if (this.index > -1) {
        this.$emit('select', this.items[this.index]);
        this.blur();
      } else if (this.suggestionItem) {
        this.$emit('select', this.suggestionItem);
        this.blur();
      } else {
        this.$emit('enter');
      }
    },

    onTab: function onTab (e) {
      if (e.shiftKey || e.altKey) { return }

      if (this.q.length && this.q !== this.suggestion) {
        this.q = this.suggestion;

        e.preventDefault();
      }

      if (this.items.length >= 1 && this.q.length && this.q === this.suggestion) {
        this.$emit('select', this.items[0]);
      }
    },

    onBlur: debounce(function onBlur() {
      if (this.skip) {
        this.skip = false;

        return
      }

      this.close();
      this.$emit('blur');
    }, 400),

    blur: function blur () {
      this.$el.querySelector('input[type=search]').blur();
    },

    close: function close () {
      this.show = false;
      this.index = -1;
      this.q = '';
    },

    scrollIntoView: function scrollIntoView () {
      var this$1 = this;

      this.$nextTick(function () {
        var el = this$1.$el.querySelector('.dropdown-menu .active');

        if (!el) { return }

        if (el.scrollIntoViewIfNeeded) {
          el.scrollIntoViewIfNeeded();
        } else if (el.scrollIntoView) {
          el.scrollIntoView();
        }
      });
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('keep-open', function () {
      this$1.skip = true;
      this$1.$el.querySelector('input[type=search]').focus();
    });
  },

  components: { Dropdown: Dropdown, SearchField: SearchField },

  directives: { onClickAway: vueClickaway.directive }
};

var InputTypeahead = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('typeahead-field',_vm._b({ref:"ta",attrs:{"id":_vm.id},on:{"select":_vm.onInput,"search":function (any) { return _vm.$emit('search', any); },"enter":function (any) { return _vm.$emit('enter', any); },"blur":function (any) { return _vm.$emit('blur', any); }},model:{value:(_vm.selected),callback:function ($$v) {_vm.selected=$$v;}}},'typeahead-field',{ required: _vm.required, autofocus: _vm.autofocus, suggestions: _vm.suggestions, suggestionKey: _vm.suggestionKey, search: _vm.search, filter: _vm.filter, component: _vm.component, showEmpty: _vm.showEmpty, inputClass: _vm.inputClass, placeholder: _vm.placeholder, icon: false, name: _vm.name })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputTypeahead',

  props: Object.assign({}, {suggestionKey: {
      type: String,
      default: 'id'
    },

    placeholder: {
      type: String,
      default: ''
    }},

    mapObject(TypeaheadField.props, [
      'suggestions', 'suggestionValue', 'search', 'filter', 'component', 'showEmpty'
    ])),

  computed: {
    selected: function selected () {
      var items = this.suggestions;
      var key = this.suggestionKey;
      var value = this.value instanceof Array ? this.value : [this.value];

      return items.filter(function (item) { return value.indexOf(item[key]) > -1; })
    },
  },

  methods: {
    onInput: function onInput (item) {
      var id = item[this.suggestionKey];

      if (this.value instanceof Array) {
        var index = this.value.indexOf(id);
        var value = this.value.slice();

        if (index > -1) {
          value.splice(index, 1);
        } else {
          value.push(id);
        }

        this.$emit('input', value);
        this.$refs.ta.$emit('keep-open');
      } else {
        this.$emit('input', id);
      }
    }
  },

  components: { TypeaheadField: TypeaheadField },
  mixins: [inputHelper]
};

var CustomModal = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.showing)?_c('div',{staticClass:"bootstrap-for-vue-CustomModal-custom-modal",attrs:{"tabindex":"1"},on:{"keydown":function($event){if(_vm._k($event.keyCode,"esc",27)){ return null; }$event.stopPropagation();_vm.$emit('close');}}},[_c('div',{staticClass:"bootstrap-for-vue-CustomModal-backdrop"}),_c('div',{ref:"wrapper",staticClass:"bootstrap-for-vue-CustomModal-wrapper",class:[_vm.wrapper || _vm.$style.wrapperDefault ],on:{"click":function($event){$event.stopPropagation();_vm.onWrapper($event);}}},[_vm._t("default")],2),(_vm.dismissable)?_c('a',{staticClass:"bootstrap-for-vue-CustomModal-dismiss",attrs:{"role":"button"},on:{"click":function($event){$event.preventDefault();_vm.$emit('close');}}},[_vm._v("×")]):_vm._e()]):_vm._e()},staticRenderFns: [],cssModules: {"customModal":"bootstrap-for-vue-CustomModal-custom-modal","custom-modal":"bootstrap-for-vue-CustomModal-custom-modal","backdrop":"bootstrap-for-vue-CustomModal-backdrop","inverse":"bootstrap-for-vue-CustomModal-inverse","dismiss":"bootstrap-for-vue-CustomModal-dismiss","wrapper":"bootstrap-for-vue-CustomModal-wrapper","wrapperDefault":"bootstrap-for-vue-CustomModal-wrapper-default","wrapper-default":"bootstrap-for-vue-CustomModal-wrapper-default"},
  name: 'Modal',

  props: {
    open: {
      default: null,
      type: Boolean
    },
    dismissOnBackdrop: {
      default: true,
      type: Boolean
    },
    wrapper: {
      type: String
    },
    dismissable: {
      type: Boolean,
      default: true
    }
  },

  data: function data () {
    return { state: false }
  },

  computed: {
    $style: function $style () {
      return this.$options.cssModules
    },

    showing: function showing () {
      var open = this.open;
      var state = this.state;

      if (open !== null) {
        return open
      }

      return state
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('open', function () {
      this$1.state = true;
    });

    this.$on('close', function () {
      this$1.state = false;
    });
  },
  methods: {
    onWrapper: function onWrapper (event) {
      if (!this.dismissable) { return }

      if (this.dismissOnBackdrop && this.$refs.wrapper === event.target) {
        this.$emit('close');
      }
    }
  },

  watch: {
    showing: function showing (state) {
      if (state) {
        document.body.classList.add('modal-open');
      } else {
        document.body.classList.remove('modal-open');
      }
    }
  }
};

var BootstrapModal = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.inDOM)?_c('div',{staticClass:"modal"},[_c('div',{staticClass:"modal-dialog",class:( obj = {}, obj[("modal-" + (_vm.size))] = _vm.size !== undefined, obj ),attrs:{"role":"document"}},[_c('div',{staticClass:"modal-content"},[(_vm.enableHeader)?_c('div',{staticClass:"modal-header"},[_vm._t("header",[_c('h5',{staticClass:"modal-title"},[_vm._t("title",[_vm._v(_vm._s(_vm.title))])],2)]),_c('button',{staticClass:"close",attrs:{"type":"button","aria-label":"Close"},on:{"click":function($event){_vm.$emit('close');}}},[_c('span',{attrs:{"aria-hidden":"true"}},[_vm._v("×")])])],2):_vm._e(),_c('div',{staticClass:"modal-body"},[_vm._t("default")],2),(_vm.enableFooter)?_c('div',{staticClass:"modal-footer"},[_vm._t("footer")],2):_vm._e()])])]):_vm._e()
var obj;},staticRenderFns: [],
  props: {
    enableFooter: {
      type: Boolean,
      default: false
    },

    enableHeader: {
      type: Boolean,
      default: true
    },

    title: {
      type: String
    },

    size: {
      type: String
    },

    open: {
      type: Boolean,
      default: null
    }
  },

  data: function data () {
    return { state: false, inDOM: false, selector: null }
  },

  computed: {
    shown: function shown () {
      var open = this.open;
      var state = this.state;

      if (open !== null) { return open }

      return state
    }
  },

  methods: {
    onShow: function onShow () {
      var this$1 = this;

      this.inDOM = true;

      this.$nextTick(function () { return this$1.showModal(); });
    },

    showModal: function showModal () {
      var this$1 = this;

      this.selector = jQuery(this.$el);
      this.selector.modal();
      this.selector.on('hidden.bs.modal', function () {
        this$1.inDOM = false;
        this$1.selector = null;
      });
    },

    onHide: function onHide () {
      if (this.selector) { this.selector.modal('hide'); }
    }
  },

  created: function created () {
    var this$1 = this;

    this.$on('show', function () { return this$1.onShow(); });
    this.$on('hide', function () { return this$1.onHide(); });
  },

  watch: {
    open: function open (shown) {
      if (shown === true) {
        this.onShow();
      } else if (shown === false) {
        this.onHide();
      }
    }
  }
};

var Modal = {
  functional: true,

  render: function render (h, ref) {
    var props = ref.props;
    var data = ref.data;
    var children = ref.children;

    if (props.custom) { return h(CustomModal, data, children) }

    return h(BootstrapModal, data, children)
  },

  props: {
    custom: {
      type: Boolean,
      default: false
    }
  }
};

var Tooltip = {
  bind: function bind (el, binding) {
    el.setAttribute('data-title', binding.value);

    jQuery(el).tooltip({
      animation: false,
      html: binding.modifiers.html || false,
      placement: binding.arg || 'bottom',
      trigger: 'hover'
    });
  },

  update: function update (el, binding) {
    if (binding.value !== binding.oldValue) {
      el.setAttribute('data-original-title', binding.value);
    }
  },

  unbind: function unbind (el) {
    jQuery(el).tooltip('hide').tooltip('dispose');
  }
};

var ErrorBag = function ErrorBag (errors) {
  this.errors = typeof (errors) === 'object' ? errors : {};
};

ErrorBag.prototype.has = function has (key) {
  return this.errors.hasOwnProperty(key)
};

ErrorBag.prototype.get = function get (key) {
  var value = this.errors[key];

  if (isArray(value)) {
    return value.join(' ')
  }

  return value
};

function prepareErrors (payload) {
  return new ErrorBag(payload)
}

var formHelper = {
  data: function data () {
    return { formErrors: {}, formStatus: null }
  },
  computed: {
    errors: function errors () {
      var errors = this.formErrors;

      return prepareErrors(errors)
    }
  },
  methods: {
    setErrors: function setErrors (payload) {
      var this$1 = this;

      this.clearErrors();

      if (payload instanceof Promise) {
        payload.json()
          .then(function (errors) { return this$1.$set(this$1, 'formErrors', errors); })
          .catch(function (error) { return this$1.$set(this$1, 'formStatus', { message: 'Cannot process form errors.', error: error }); });
      } else {
        this.formErrors = payload;
      }
    },
    clearErrors: function clearErrors (key) {
      if (key === undefined) {
        this.formErrors = {};
        this.formStatus = null;
      } else if (key in this.formErrors) {
        this.formErrors[key] = null;
      }
    }
  }
};

var DIRECTIVES = {
  Tooltip: Tooltip
};

var INPUT = {
  CheckboxWrapper: CheckboxWrapper, // Wrapper for Box
  InputBox: InputBox, // Checkbox & Radio
  InputButton: InputButton, // Button
  InputSearch: InputSearch,
  InputSelect: InputSelect, // Select
  InputText: InputText, // Text, Number etc.
  InputTextarea: InputTextarea,
  InputTypeahead: InputTypeahead
};

var OTHERS = {
  Alert: Alert,
  Breadcrumb: Breadcrumb,
  Dropdown: Dropdown,
  Icon: Icon,
  Modal: Modal,
  Search: SearchField,
  Typeahead: TypeaheadField
};

function each (obj, callback) {
  Object.keys(obj).forEach(function (key) { return callback(obj[key], key); });
}

function installComponents (Vue, components) {
  each(components, function (component, name) { return Vue.component(name, component); });
}

function plugin (Vue, options) {
  if ( options === void 0 ) options = {};

  installComponents(Vue, INPUT);
  each(DIRECTIVES, function (directive$$1, name) { return Vue.directive(name, directive$$1); });

  if (options.custom === true) {
    Modal.props.custom.default = true;
    InputBox.props.custom.default = true;
  }

  if (options.all) {
    installComponents(Vue, OTHERS);
  }
}

// Install by default if using the script tag
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(plugin, window.bootstrapForVueConfig || {});
}

exports.DIRECTIVES = DIRECTIVES;
exports.INPUT = INPUT;
exports.OTHERS = OTHERS;
exports['default'] = plugin;
exports.formHelper = formHelper;
exports.ErrorBag = ErrorBag;
